import fs from "fs";
import path from "path";
import utils from "node-pearls";
import ConvertSourceMap from "convert-source-map";

function imageLoader(content) {
	const callback = this.async();
	const outputPath = this.output;
	const ext = path.extname(this.file);
	const limit = this.params.limit || 0;
	var ret = "", sourcemapComment = "";
	if (process.env.SM) {
		let relativeFile = "/" + path.join(this.packageJson.name, this.file.replace(this.packagePath, ""));
		sourcemapComment = "\n" + ConvertSourceMap.fromObject({
			version: 3,
			file: relativeFile,
			sourceRoot: "",
			sources: [relativeFile],
			names: [],
			mappings: "AAAA",
			sourcesContent: ["这是一张图片"]
		}).toComment();
	}
	if (content.length < limit) {
		let str = "data:image/" + ext.replace(".", "") + ";base64," + content.toString("base64");
		ret = `var image = "${str}" ;
			module.exports = image`;
		callback(ret + sourcemapComment);
	} else {
		let fileMd5Name = utils.md5(content) + ext;
		let file = path.join(outputPath, fileMd5Name);
		utils.mkdirs.sync(outputPath);
		fs.writeFile(file, content, function (err) {
			if (err) {
				console.error(`图片${file}写入失败`);
			}
			ret = `module.exports = __dirname + "/${fileMd5Name}"`;
			callback(ret + sourcemapComment);
		});
	}
};
imageLoader.raw = true;
export default imageLoader;